var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _extendableBuiltin(cls) {
  function ExtendableBuiltin() {
    var instance = Reflect.construct(cls, Array.from(arguments));
    Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
    return instance;
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

var proauth = function () {
  'use strict';

  var _this = this;

  var absolutePath = function (href) {
    _newArrowCheck(this, _this);

    var link = document.createElement("a");
    link.href = href;
    return String(link.protocol) + "//" + String(link.host) + String(link.pathname) + String(link.search) + String(link.hash);
  }.bind(this);

  var originalFetch$1 = window.fetch;

  var fetch$1 = function fetch$1(input, init) {
    var _this2 = this;

    return new Promise(function (resolve) {
      _newArrowCheck(this, _this2);

      var request = new Request(input, init);

      if (originalFetch$1.polyfill) {
        // fetch polyfill does not absolutize the url, so...
        request.url = absolutePath(request.url);
      }

      var fetchEvent = new CustomEvent("fetch");
      fetchEvent.request = request;
      fetchEvent.respondWith = resolve;
      this.dispatchEvent(fetchEvent); // eslint-disable-line no-invalid-this

      // (todo): when to reject?
    }.bind(this));
  };

  var fetch$2 = {
    install: function install(observer) {
      _newArrowCheck(this, _this);

      window.fetch = fetch$1.bind(observer);
    }.bind(this),
    uninstall: function uninstall() {
      _newArrowCheck(this, _this);

      window.fetch = originalFetch$1;
    }.bind(this),
    fetch: originalFetch$1
  };

  var originalXMLHttpRequest = window.XMLHttpRequest;

  var _readyState = Symbol("readyState");
  var _responseBody = Symbol("responseBody");
  var _response = Symbol("response");
  var _requestHeaders = Symbol("requestHeaders");
  var _method = Symbol("method");
  var _url = Symbol("url");
  var _username = Symbol("username");
  var _password = Symbol("password");
  var _sendFlag = Symbol("sendFlag");
  var _errorFlag = Symbol("errorFlag");
  var _forceMimeType = Symbol("forceMimeType");
  var _responseHeaders = Symbol("responseHeaders");
  var _aborted = Symbol("aborted");
  var _withCredentials = Symbol("withCredentials");

  var responseParser = {
    "": "text",
    "arraybuffer": "arrayBuffer",
    "blob": "blob",
    "json": "json",
    "text": "text"
  };

  /*
    Without mocking, the native XMLHttpRequest object will throw
    an error when attempting to set these headers. We match this behavior.
  */
  var unsafeHeaders = {
    "accept-charset": true,
    "accept-encoding": true,
    "connection": true,
    "content-length": true,
    "cookie": true,
    "cookie2": true,
    "content-transfer-encoding": true,
    "date": true,
    "expect": true,
    "host": true,
    "keep-alive": true,
    "referer": true,
    "te": true,
    "trailer": true,
    "transfer-encoding": true,
    "upgrade": true,
    "user-agent": true,
    "via": true
  };

  var throwMethodError = function throwMethodError(method, message) {
    throw new Error("Failed to execute '" + String(method) + "' on 'XMLHttpRequest': " + String(message) + ".");
  };

  var throwReadPropError = function throwReadPropError(property, message) {
    throw new Error("Failed to read the '" + String(property) + "' property from 'XMLHttpRequest': " + String(message) + ".");
  };

  var verifyState = function verifyState(xhr, method) {
    if (xhr.readyState !== XMLHttpRequest.OPENED) {
      throwMethodError(method, "The object's state must be OPENED");
    }

    if (xhr[_sendFlag]) {
      throwMethodError(method, "Already sent");
    }
  };

  /*
    Cross-browser XML parsing. Used to turn
    XML responses into Document objects
    Borrowed from JSpec
  */
  var parseXML = function parseXML(text) {
    var xmlDoc = null;

    if (typeof DOMParser !== "undefined") {
      var parser = new DOMParser();
      xmlDoc = parser.parseFromString(text, "text/xml");

      // Return an XML parse error to get namespace of "parsererror" tag
      var parsererrorNS = parser.parseFromString("INVALID", "text/xml").getElementsByTagName("parsererror")[0].namespaceURI;

      // Check if xmlDoc resulted in an XML parse error
      if (xmlDoc.getElementsByTagNameNS(parsererrorNS, "parsererror").length > 0) {
        return null;
      }
    } else {
      xmlDoc = new ActiveXObject("Microsoft.XMLDOM"); // eslint-disable-line no-undef
      xmlDoc.async = "false";
      xmlDoc.loadXML(text);
    }

    return xmlDoc;
  };

  /**
   * Places a XMLHttpRequest object into the passed state.
   *
   * @param {XMLHttpRequest} xhr The XHR object
   * @param {string} state The ready state
   * @return {void}
   */
  var readyStateChange = function readyStateChange(xhr, state) {
    xhr[_readyState] = state;
    xhr.dispatchEvent(new Event("readystatechange"));
  };

  var XMLHttpRequestToFetch = function (_extendableBuiltin2) {
    _inherits(XMLHttpRequestToFetch, _extendableBuiltin2);

    function XMLHttpRequestToFetch() {
      _classCallCheck(this, XMLHttpRequestToFetch);

      return _possibleConstructorReturn(this, _extendableBuiltin2.apply(this, arguments));
    }

    /**
     * Duplicates the behavior of native XMLHttpRequest's open function
     *
     * @param {string} method Method of the request
     * @param {string} url URL of the request
     * @param {boolean} async Wheter to make the request synchronously or not
     * @param {string} username Username to use in the request
     * @param {string} password Password to use in the request
     * @returns {void}
     */
    XMLHttpRequestToFetch.prototype.open = function open(method, url) {
      var async = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var username = arguments[3];
      var password = arguments[4];
      // eslint-disable-line max-params

      if (method === undefined || url === undefined) {
        throw new TypeError("Not enough arguments to XMLHttpRequest.open");
      }

      if (!async) {
        if (console && console.warn) {
          console.warn("Synchronous XHR are not supported");
        }
      }

      this[_method] = method;
      this[_url] = url;
      this[_username] = username;
      this[_password] = password;
      this[_requestHeaders] = {};
      this[_sendFlag] = false;
      readyStateChange(this, this.OPENED);
    };

    /**
     * Duplicates the behavior of native XMLHttpRequest's setRequestHeader function
     *
     * @param {string} header Header key
     * @param {string} value Header value
     * @returns {void}
     */


    XMLHttpRequestToFetch.prototype.setRequestHeader = function setRequestHeader(header, value) {
      verifyState(this, "setRequestHeader");

      if (unsafeHeaders[String(header).toLowerCase()] || /^(Sec-|Proxy-)/i.test(header)) {
        console.error("Refused to set unsafe header '" + String(header) + "'");
        return;
      }

      if (this[_requestHeaders][header]) {
        this[_requestHeaders][header] += "," + String(value);
      } else {
        this[_requestHeaders][header] = value;
      }
    };

    /**
     * Duplicates the behavior of native XMLHttpRequest's send function
     *
     * @param {object|null} data Request body
     * @returns {void}
     */


    XMLHttpRequestToFetch.prototype.send = function send(data) {
      var _this4 = this;

      verifyState(this, "send");
      this[_errorFlag] = false;
      this[_sendFlag] = true;

      this.dispatchEvent(new ProgressEvent("loadstart", { bubbles: false, cancelable: false }));
      //this.dispatchEvent(new ProgressEvent("progress", { bubbles: false, cancelable: false }))

      var fetchInit = {
        method: this[_method],
        headers: this[_requestHeaders],
        body: data
        // mode: // NOT supported by xhr
        // credentials: // TODO
      };

      if (this[_withCredentials]) {
        fetchInit.credentials = "include";
      }

      var p = Promise.race([fetch(this[_url], fetchInit).then(function (response) {
        _newArrowCheck(this, _this4);

        return response;
      }.bind(this), function (reason) {
        _newArrowCheck(this, _this4);

        return new Promise(function (resolve, reject) {
          _newArrowCheck(this, _this4);

          return reject(reason);
        }.bind(this));
      }.bind(this)), new Promise(function (resolve, reject) {
        _newArrowCheck(this, _this4);

        if (this.timeout > 0) {
          setTimeout(function () {
            _newArrowCheck(this, _this4);

            return reject(new Error("request timeout"));
          }.bind(this), this.timeout);
        }
      }.bind(this))]);

      p.then(function (response) {
        _newArrowCheck(this, _this4);

        // fetch resolved

        this[_response] = response;

        // HEADERS_RECEIVED Stage
        var headers = response.headers;
        this[_responseHeaders] = {};
        headers.forEach(function (value, key) {
          _newArrowCheck(this, _this4);

          if (this[_forceMimeType] && key.toLowerCase() === "content-type") {
            this[_responseHeaders][key] = this[_forceMimeType];
          } else {
            this[_responseHeaders][key] = value;
          }
        }.bind(this));

        readyStateChange(this, this.HEADERS_RECEIVED);

        // LOADING Stage
        readyStateChange(this, this.LOADING);
        this.dispatchEvent(new ProgressEvent("progress", { bubbles: false, cancelable: false }));
        // TODO: do we need body size?

        return response[responseParser[this.responseType] || "text"]();
      }.bind(this), function (reason) {
        _newArrowCheck(this, _this4);

        // fetch rejected || request timeout
        readyStateChange(this, this.DONE);

        if (reason instanceof Error && reason.message === "request timeout") {
          // request timeout
          this.dispatchEvent(new ProgressEvent("timeout", { bubbles: false, cancelable: false }));
        } else if (!this[_aborted]) {
          // fetch rejected
          this.dispatchEvent(new ProgressEvent("error", { bubbles: false, cancelable: false }));
        }

        return new Promise(function (resolve, reject) {
          _newArrowCheck(this, _this4);

          return reject(reason);
        }.bind(this));
      }.bind(this)).then(function (body) {
        _newArrowCheck(this, _this4);

        // fetch resolved && body is ready
        if (!this[_aborted] && this[_readyState]) {
          this[_responseBody] = body;
          this[_sendFlag] = false;
          readyStateChange(this, this.DONE);
          this.dispatchEvent(new ProgressEvent("load", { bubbles: false, cancelable: false }));
        }
      }.bind(this)).then(
      // finally, fire loadend event when the fetch completed (success or failure)
      function () {
        _newArrowCheck(this, _this4);

        this.dispatchEvent(new ProgressEvent("loadend", { bubbles: false, cancelable: false }));
      }.bind(this), function () {
        _newArrowCheck(this, _this4);

        this.dispatchEvent(new ProgressEvent("loadend", { bubbles: false, cancelable: false }));
      }.bind(this));
    };

    /**
     * Duplicates the behavior of native XMLHttpRequest's abort function
     *
     * @returns {void}
     */


    XMLHttpRequestToFetch.prototype.abort = function abort() {
      this[_aborted] = true;
      this[_errorFlag] = true;
      this[_requestHeaders] = {};

      if (this[_readyState] === this.OPENED && this[_sendFlag] || this[_readyState] === this.HEADERS_RECEIVED || this[_readyState] === this.LOADING) {
        readyStateChange(this, this.DONE);
        this[_sendFlag] = false;
      }

      this[_readyState] = this.UNSENT;

      this.dispatchEvent(new ProgressEvent("abort", { bubbles: false, cancelable: false }));
    };

    /**
     * Duplicates the behavior of native XMLHttpRequest's getResponseHeader function
     *
     * @param {string} header Header key
     * @returns {string|null} Header value
     */


    XMLHttpRequestToFetch.prototype.getResponseHeader = function getResponseHeader(header) {
      if (this[_readyState] < this.HEADERS_RECEIVED) {
        return null;
      }

      if (/^Set-Cookie2?$/i.test(header)) {
        return null;
      }

      header = header.toLowerCase();

      for (var h in this[_responseHeaders]) {
        if (h.toLowerCase() === header) {
          return this[_responseHeaders][h];
        }
      }

      return null;
    };

    /**
     * Duplicates the behavior of native XMLHttpRequest's getAllResponseHeaders function
     *
     * @returns {array} List of response headers
     */


    XMLHttpRequestToFetch.prototype.getAllResponseHeaders = function getAllResponseHeaders() {
      if (this[_readyState] < this.HEADERS_RECEIVED) {
        return "";
      }

      var responseHeaders = this[_responseHeaders];
      if (responseHeaders && responseHeaders.length) {
        // Clone headers and sort them (@see https://xhr.spec.whatwg.org/#dom-xmlhttprequest-getallresponseheaders)
        responseHeaders = responseHeaders.slice().sort();
      }
      var headers = "";

      for (var header in responseHeaders) {
        if (responseHeaders.hasOwnProperty(header) && !/^Set-Cookie2?$/i.test(header)) {
          headers += header + ": " + String(responseHeaders[header]) + "\r\n";
        }
      }

      return headers;
    };

    /**
     * Duplicates the behavior of native XMLHttpRequest's overrideMimeType function
     *
     * @param {string} mimeType MimeType that will be used
     * @returns {void}
     */


    XMLHttpRequestToFetch.prototype.overrideMimeType = function overrideMimeType(mimeType) {
      if (typeof mimeType === "string") {
        this[_forceMimeType] = mimeType.toLowerCase();
      }
    };

    _createClass(XMLHttpRequestToFetch, [{
      key: "readyState",
      get: function get() {
        return this[_readyState] || this.UNSENT;
      }
    }, {
      key: "status",
      get: function get() {
        return this[_response] ? this[_response].status : 0;
      }
    }, {
      key: "statusText",
      get: function get() {
        return this[_response] ? this[_response].statusText : "";
      }
    }, {
      key: "response",
      get: function get() {
        // https://xhr.spec.whatwg.org/#xmlhttprequest-response
        var type = this.responseType;
        var state = this[_readyState];
        if (type === "" || type === "text") {
          return state !== this.LOADING && state !== this.DONE ? "" : this[_responseBody];
        }

        if (state !== this.DONE) {
          return null;
        }

        return this[_responseBody];
      }
    }, {
      key: "responseURL",
      get: function get() {
        if (this[_response] && this.readyState === this.DONE) {
          return this[_response].url;
        }

        return "";
      }
    }, {
      key: "responseText",
      get: function get() {
        var responseType = this.responseType;
        if (responseType !== "" && responseType !== "text") {
          throwReadPropError("responseType", "The value is only accessible if the object's 'responseType' is '' " + ("or 'text' (was '" + String(responseType) + "')"));
        }

        var state = this[_readyState];
        if (state !== this.LOADING && state !== this.DONE) {
          return "";
        }

        return this[_responseBody] || "";
      }
    }, {
      key: "responseXML",
      get: function get() {
        var responseType = this.responseType;
        if (responseType !== "" && responseType !== "document") {
          throwReadPropError("responseXML", "The value is only accessible if the object's 'responseType' is '' " + ("or 'document' (was '" + String(responseType) + "')"));
        }

        var body = this[_responseBody];

        if (this[_readyState] !== this.DONE || !!body) {
          return null;
        }

        var finalMimeType = this.getResponseHeader("Content-Type");

        if (finalMimeType !== null && !/(text\/html)|(text\/xml)|(application\/xml)|(\+xml)/i.test(finalMimeType)) {
          return null;
        }

        if (responseType === "" && finalMimeType === "text/html") {
          return null;
        }

        return parseXML(body);
      }
    }, {
      key: "withCredentials",
      get: function get() {
        return this[_withCredentials] || false;
      },
      set: function set(enable) {
        this[_withCredentials] = !!enable;
      }
    }]);

    return XMLHttpRequestToFetch;
  }(_extendableBuiltin(XMLHttpRequest));

  var xhr = {
    install: function install() {
      _newArrowCheck(this, _this);

      window.XMLHttpRequest = XMLHttpRequestToFetch;
    }.bind(this),
    uninstall: function uninstall() {
      _newArrowCheck(this, _this);

      window.XMLHttpRequest = originalXMLHttpRequest;
    }.bind(this),
    XMLHttpRequest: originalXMLHttpRequest
  };

  var EventTarget =

  /**
   * Create an event target.
   */
  function EventTarget() {
    var _this5 = this;

    _classCallCheck(this, EventTarget);

    var delegate = document.createDocumentFragment();
    var _arr = ["addEventListener", "dispatchEvent", "removeEventListener"];

    var _loop = function _loop() {
      var fx = _arr[_i];
      _this5[fx] = function () {
        _newArrowCheck(this, _this5);

        return delegate[fx].apply(delegate, arguments);
      }.bind(_this5);
    };

    for (var _i = 0; _i < _arr.length; _i++) {
      _loop();
    }
  };

  var _postMessage = function (target, aMessage, transferList) {
    _newArrowCheck(this, _this);

    var ports = [];
    for (var _iterator = transferList || [], _isArray = Array.isArray(_iterator), _i2 = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i2 >= _iterator.length) break;
        _ref = _iterator[_i2++];
      } else {
        _i2 = _iterator.next();
        if (_i2.done) break;
        _ref = _i2.value;
      }

      var transfer = _ref;

      if (transfer instanceof MessagePort) {
        ports.push(transfer);
      }
    }

    var e = new MessageEvent("message", {
      bubbles: false,
      cancelable: true,
      data: aMessage,
      ports: ports.length > 0 ? ports : undefined
    });

    if (target.onmessage) {
      target.onmessage(e);
    }

    target.dispatchEvent(e);
  }.bind(this);

  var ServiceWorker = function (_EventTarget) {
    _inherits(ServiceWorker, _EventTarget);

    /**
     * Create a custom worker.
     */
    function ServiceWorker() {
      _classCallCheck(this, ServiceWorker);

      // Service worker context.
      // Ie., A fake of ServiceWorkerGlobalScope.
      // The variable `globalScope` is equivalent to the `self` field of the Service Worker.
      // It will be used by the proauth.service.Controller as the ServiceWorker's global scope object.
      var _this6 = _possibleConstructorReturn(this, _EventTarget.call(this));

      var globalScope = new EventTarget();

      var self = _this6;
      globalScope.clients = {
        matchAll: function matchAll() {
          var _this7 = this;

          return new Promise(function (resolve) {
            _newArrowCheck(this, _this7);

            resolve([{
              postMessage: function postMessage() {
                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = arguments[_key];
                }

                _newArrowCheck(this, _this7);

                return _postMessage.apply(undefined, [self].concat(args));
              }.bind(this)
            }]);
          }.bind(this));
        }
      };

      // Client context
      // Used to send message from the client to the service worker
      _this6.controller = new (function () {
        function _class() {
          _classCallCheck(this, _class);
        }

        _class.prototype.postMessage = function postMessage() {
          for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          return _postMessage.apply(undefined, [globalScope].concat(args));
        };

        return _class;
      }())();

      _this6.self = globalScope;

      return _this6;
    }

    return ServiceWorker;
  }(EventTarget);

  var OAuth2Response = function () {

    /**
     * Create an OAuth2.0 response.
     *
     * @param {Response} data The response
     */
    function OAuth2Response(data) {
      _classCallCheck(this, OAuth2Response);

      this.accessToken = data.access_token;
      this.refreshToken = data.refresh_token;
      this.expiresIn = data.expires_in;
      this.tokenType = data.token_type;
      this.scope = data.scope;
    }

    OAuth2Response.prototype.toObject = function toObject() {
      return Object.assign({}, this);
    };

    return OAuth2Response;
  }();

  var OAuth2Error = function () {

    /**
     * Create an OAuth2.0 error.
     *
     * @param {Response} response The response
     */
    function OAuth2Error(response) {
      _classCallCheck(this, OAuth2Error);

      this.response = response;
    }

    _createClass(OAuth2Error, [{
      key: "status",
      get: function get() {
        return this.response.status || null;
      }
    }, {
      key: "title",
      get: function get() {
        return this.response.title || null;
      }
    }, {
      key: "detail",
      get: function get() {
        return this.response.detail || null;
      }
    }]);

    return OAuth2Error;
  }();

  var OAuth2Client = function () {

    /**
     * Create an OAuth2.0 client instance.
     *
     * @param {string} apiUrl The url of OAuth2 endpoint
     * @param {string} clientId A string identifying the instance of the client
     * @param {Function} fetch The fetch function the client will use
     */
    function OAuth2Client(apiUrl, clientId, fetch) {
      var _this8 = this;

      _classCallCheck(this, OAuth2Client);

      /** @type {string} */
      this.apiUrl = apiUrl;

      /** @type {string} */
      this.clientId = clientId;

      this.fetch = function (init) {
        _newArrowCheck(this, _this8);

        return fetch(this.apiUrl, init);
      }.bind(this);
    }

    OAuth2Client.prototype.handleAuthenticationResponse = function handleAuthenticationResponse(response) {
      var _this9 = this;

      if (response.ok) {
        // Authentication OK
        return response.json().then(function (j) {
          _newArrowCheck(this, _this9);

          return new OAuth2Response(j);
        }.bind(this));
      }

      // Authentication refused
      return response.json().then(function (j) {
        _newArrowCheck(this, _this9);

        return Promise.reject(new OAuth2Error(j));
      }.bind(this));
    };

    /**
     * Grant an access token.
     *
     * @param {Object} params An object containing the parameters to post to the OAuth2 endpoint
     * @return {Promise} A promise
     * @private
     */


    OAuth2Client.prototype.grantAccessToken = function grantAccessToken(params) {
      return this.fetch({
        method: "POST",
        headers: {
          "Content-Type": "application/json",
          "Accept": "application/json"
        },
        body: JSON.stringify(params)
      });
    };

    /**
     * Grant a token for an user.
     *
     * @param {String} username The user for which to request a token
     * @param {String} password The password to authenticate such user
     * @return {Promise} A promise
     */


    OAuth2Client.prototype.userCredentials = function userCredentials(username, password) {
      return this.grantAccessToken({
        "client_id": this.clientId,
        "grant_type": "password",
        username: username,
        password: password
      });
    };

    /**
     * Refresh an overdue token.
     *
     * @param {String} refreshToken The token to refresh
     * @return {Promise} A promise
     */


    OAuth2Client.prototype.refreshToken = function refreshToken(_refreshToken) {
      return this.grantAccessToken({
        "client_id": this.clientId,
        "grant_type": "refresh_token",
        "refresh_token": _refreshToken
      });
    };

    return OAuth2Client;
  }();

  var attachAuthorization = function (session, request) {
    _newArrowCheck(this, _this);

    var tokens = session.content || {};

    if (tokens.accessToken) {

      /*
       * We have to create a new request based on the old one because the headers of the
       * original request are immutable in ServiceWorker.
       * Note that this is unnecessary if the code doesn't run in the ServiceWorker.
       * TODO: search for a better way to achieve the same result.
       */
      request = new Request(request);

      request.headers.set("Authorization", String(tokens.tokenType) + " " + String(tokens.accessToken));
    }

    return request;
  }.bind(this);

  var updateSession = function (session, grantPromise) {
    _newArrowCheck(this, _this);

    return grantPromise.then(function (oA2Response) {
      _newArrowCheck(this, _this);

      session.content = oA2Response.toObject();
      return true;
    }.bind(this), function (oA2Error) {
      _newArrowCheck(this, _this);

      session.clear();
      return false;
    }.bind(this));
  }.bind(this);

  var Oauth2Handler = function () {

    /**
     * Create an OAuth2.0 handler.
     *
     * @param {Object} settings The settings
     * @param {SessionHandler} session The session
     * @param {Function} fetch The fetch function
     */
    function Oauth2Handler(settings, session, fetch) {
      _classCallCheck(this, Oauth2Handler);

      this.settings = settings;
      this.session = session;
      this.fetch = fetch;
      this.oauth2Client = new OAuth2Client(settings.oauthUrl, settings.oauthClientId, fetch);
      this.invalidGrantHttpCode = 401;
    }

    /**
     * Update the session on response
     *
     * @param {FetchEvent} event The intercepted event
     * @returns {void}
     */


    Oauth2Handler.prototype.handleAuthentication = function handleAuthentication(event) {
      var _this10 = this;

      var fetch = this.fetch;
      event.respondWith(fetch(event.request).then(function (response) {
        _newArrowCheck(this, _this10);

        // Just update the session on response
        return updateSession(this.session, this.oauth2Client.handleAuthenticationResponse(response.clone())).then(function () {
          _newArrowCheck(this, _this10);

          return response;
        }.bind(this));
      }.bind(this)));
    };

    /**
     * Set the current token and handle 401s
     *
     * @param {FetchEvent} event The intercepted event
     * @returns {void}
     */


    Oauth2Handler.prototype.handle = function handle(event) {
      var _this11 = this;

      var oauthUrl = this.settings.oauthUrl;

      var request = event.request;
      var url = request.url;
      var fetch = this.fetch;

      // Is it an auth request?
      if (url === oauthUrl || String(url) + "/" === oauthUrl) {
        this.handleAuthentication(event);
        return;
      }

      if (this._pendingRefresh) {
        // Wait for the fresh token
        this._pendingRefresh.then(function () {
          _newArrowCheck(this, _this11);

          request = attachAuthorization(this.session, request);
          event.respondWith(fetch(request));
        }.bind(this));
        return;
      }

      // Attach the current token
      request = attachAuthorization(this.session, request);

      // Finally, fetch and handle the response
      var requestCopy = request.clone();
      event.respondWith(fetch(request).then(function (response) {
        _newArrowCheck(this, _this11);

        if (this._pendingRefresh) {
          // Wait for the fresh token
          return this._pendingRefresh.then(function () {
            _newArrowCheck(this, _this11);

            requestCopy = attachAuthorization(this.session, requestCopy);
            return fetch(requestCopy);
          }.bind(this));
        }

        var tokens = this.session.content || {};
        if (response.status === this.invalidGrantHttpCode && tokens.refreshToken) {
          // Got 401, but we have a refresh token, so try to get a new access token

          var resetPending = function (param) {
            _newArrowCheck(this, _this11);

            this._pendingRefresh = null;
            return param;
          }.bind(this);

          var oauth = this.oauth2Client;
          this._pendingRefresh = oauth.refreshToken(tokens.refreshToken).then(resetPending, resetPending).then(function (authResponse) {
            _newArrowCheck(this, _this11);

            return updateSession(this.session, oauth.handleAuthenticationResponse(authResponse)).then(function (newSession) {
              _newArrowCheck(this, _this11);

              // We got a new token?
              // Then try to re-fetch the original request...
              if (newSession) {
                requestCopy = attachAuthorization(this.session, requestCopy);
                return fetch(requestCopy);
              } //...else passthrough the 401 response
              return response;
            }.bind(this));
          }.bind(this));
          return this._pendingRefresh;
        }
        return response; // Passthrough any others
      }.bind(this)));
    };

    return Oauth2Handler;
  }();

  var SessionContainer = function () {

    /**
     * Create a session container.
     *
     * @param {String} namespace The namespace
     * @param {Function} notify The notifier
     * @param {Object} data The content
     */
    function SessionContainer(namespace, notify, data) {
      var _this12 = this;

      _classCallCheck(this, SessionContainer);

      this.notify = function () {
        _newArrowCheck(this, _this12);

        return notify(namespace);
      }.bind(this);
      this._content = data ? Object(data) : null;
    }

    SessionContainer.prototype.clear = function clear() {
      this.content = null;
    };

    _createClass(SessionContainer, [{
      key: "content",
      get: function get() {
        return this._content;
      },
      set: function set(data) {
        this._content = data ? Object(data) : null;
        this.notify();
      }
    }]);

    return SessionContainer;
  }();

  var Controller = function () {

    /**
     * Create a controller.
     *
     * @param {EventTarget} globalScope The Service Worker's global scope
     * @param {Function} fetch The fetch function it will use
     */
    function Controller(globalScope, fetch) {
      var _this13 = this;

      _classCallCheck(this, Controller);

      this.globalScope = globalScope;

      if (!fetch) {
        fetch = globalScope.fetch;
      }

      this.handlers = {};

      // Setup interceptor
      globalScope.addEventListener("fetch", function (event) {
        _newArrowCheck(this, _this13);

        for (var ns in this.handlers) {
          var handler = this.handlers[ns];
          for (var _iterator2 = handler.settings.managedUrls, _isArray2 = Array.isArray(_iterator2), _i3 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
            var _ref2;

            if (_isArray2) {
              if (_i3 >= _iterator2.length) break;
              _ref2 = _iterator2[_i3++];
            } else {
              _i3 = _iterator2.next();
              if (_i3.done) break;
              _ref2 = _i3.value;
            }

            var url = _ref2;

            if (event.request.url.startsWith(url)) {
              // Each managed url should be handle by just one handler,
              // further registered handler on the same url are discarded.
              // (todo): Should be a warning/error thrown in case of multiple handlers?
              handler.handle(event);
              return;
            }
          }
        }

        // Passthrough unmanaged requests
        event.respondWith(fetch(event.request));
      }.bind(this));

      globalScope.addEventListener("message", function (e) {
        _newArrowCheck(this, _this13);

        var _e$data = e.data,
            broadcast = _e$data.broadcast,
            namespace = _e$data.namespace,
            command = _e$data.command,
            params = _e$data.params;

        var reply = function () {
          var _e$ports$;

          _newArrowCheck(this, _this13);

          return (_e$ports$ = e.ports[0]).postMessage.apply(_e$ports$, arguments);
        }.bind(this);

        if (broadcast) {
          return; // Discard broadcast messages
        }

        try {
          switch (command) {
            case "init":
              (function (settings) {
                var sessionData = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

                _newArrowCheck(this, _this13);

                var ns = settings.namespace;
                var h = this.handlers[ns];

                if (namespace !== ns) {
                  throw Error("Invalid settings: namespace mismatch");
                }

                // Setup or override handler settings and session data
                if (h) {
                  h = this.getHandlerByNamespace(ns);
                  h.settings = settings;
                  h.session.content = sessionData;
                } else {
                  var s = new SessionContainer(ns, this.notifySession.bind(this), sessionData);
                  h = this.handlers[ns] = new Oauth2Handler(settings, s, fetch);
                }
              }).bind(this).apply(undefined, params);
              reply(true);
              break;

            case "setSession":
              (function (data) {
                _newArrowCheck(this, _this13);

                this.getHandlerByNamespace(namespace).session.content = data;
              }).bind(this).apply(undefined, params);
              reply(true);
              break;

            default:
              break;
          }
        } catch (error) {
          reply({
            namespace: namespace,
            error: {
              message: String(error.message),
              stack: String(error.stack)
            }
          });
        }
      }.bind(this));
    }

    Controller.prototype.getHandlerByNamespace = function getHandlerByNamespace(namespace) {
      if (!this.handlers[namespace]) {
        throw Error("No handler found for '" + String(namespace) + "'");
      }
      return this.handlers[namespace];
    };

    Controller.prototype.sendMessage = function sendMessage(namespace, command) {
      for (var _len3 = arguments.length, params = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
        params[_key3 - 2] = arguments[_key3];
      }

      var _this14 = this;

      this.globalScope.clients.matchAll().then(function (clients) {
        _newArrowCheck(this, _this14);

        for (var _iterator3 = clients, _isArray3 = Array.isArray(_iterator3), _i4 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
          var _ref3;

          if (_isArray3) {
            if (_i4 >= _iterator3.length) break;
            _ref3 = _iterator3[_i4++];
          } else {
            _i4 = _iterator3.next();
            if (_i4.done) break;
            _ref3 = _i4.value;
          }

          var _client = _ref3;

          _client.postMessage({
            broadcast: true, namespace: namespace, command: command, params: params
          });
        }
      }.bind(this));
    };

    Controller.prototype.notifySession = function notifySession(namespace) {
      this.sendMessage(namespace, "session", this.getHandlerByNamespace(namespace).session.content);
    };

    return Controller;
  }();

  var SessionContainer$1 = function () {

    /**
     * Create a session container.
     *
     * @param {String} namespace The namespace
     * @param {Storage} storage The session storage
     */
    function SessionContainer$1(namespace, storage) {
      _classCallCheck(this, SessionContainer$1);

      this.namespace = namespace;
      this.storage = storage;
    }

    SessionContainer$1.prototype.clear = function clear() {
      this.storage.removeItem(this.namespace);
    };

    _createClass(SessionContainer$1, [{
      key: "content",
      get: function get() {
        try {
          return JSON.parse(this.storage.getItem(this.namespace));
        } catch (error) {}
        return null;
      },
      set: function set(data) {
        if (data) {
          this.storage.setItem(this.namespace, JSON.stringify(data || null));
        } else {
          this.clear();
        }
      }
    }]);

    return SessionContainer$1;
  }();

  var sendMessage = function (serviceWorker, message) {
    _newArrowCheck(this, _this);

    // This wraps the message posting/response in a promise,
    // which will resolve if the response doesn't
    // contain an error, and reject with the error if it does.
    // If you'd prefer, it's possible to call
    // controller.postMessage() and set up the onmessage handler
    // independently of a promise, but this is a convenient wrapper.
    return new Promise(function (resolve, reject) {
      _newArrowCheck(this, _this);

      var messageChannel = new MessageChannel();
      messageChannel.port1.onmessage = function (event) {
        _newArrowCheck(this, _this);

        if (event.data.error) {
          reject(event.data.error);
        } else {
          resolve(event.data);
        }
      }.bind(this);

      // This sends the message data as well as transferring messageChannel.port2
      // to the service worker.
      // The service worker can then use the transferred port to reply via postMessage(),
      // which will in turn trigger the onmessage handler on messageChannel.port1.
      // See https://html.spec.whatwg.org/multipage/workers.html#dom-worker-postmessage.
      serviceWorker.controller.postMessage(message, [messageChannel.port2]);
    }.bind(this));
  }.bind(this);

  var Client = function () {

    /**
     * @typedef {Object} ClientSettings
     * @property {String} namespace
     * @property {String} oauthUrl
     * @property {String} oauthClientId
     * @property {String} sessionStorage
     */

    /**
     * Create a client.
     *
     * @param {ClientSettings} settings An object containing the client settings
     */
    function Client(settings) {
      var _this15 = this;

      _classCallCheck(this, Client);

      var namespace = settings.namespace,
          sessionStorage = settings.sessionStorage;

      this.settings = settings;
      this.sessionContainer = new SessionContainer$1(namespace, window[sessionStorage]);
      this._onMessage = function (event) {
        _newArrowCheck(this, _this15);

        var _event$data = event.data,
            broadcast = _event$data.broadcast,
            ns = _event$data.namespace,
            command = _event$data.command,
            params = _event$data.params;

        if (!broadcast || ns !== this.settings.namespace) {
          return;
        }

        switch (command) {
          case "session":
            this.sessionContainer.content = params[0];
            break;

          default:
        }

        // (todo): set session race condition must be avoided, dirty-checking data may be a solution
      }.bind(this);
    }

    Client.prototype.setSession = function setSession(data) {
      return sendMessage(this.serviceWorker, {
        namespace: this.settings.namespace,
        command: "setSession",
        params: [data]
      });
    };

    Client.prototype.clearSession = function clearSession() {
      return this.setSession(null);
    };

    Client.prototype.hasSession = function hasSession() {
      return !!this.sessionContainer.content;
    };

    Client.prototype.login = function login(user, pass) {
      var _this16 = this;

      if (!this.ready) {
        throw Error("proauth.js is not ready yet.");
      }
      var _settings = this.settings,
          oauthUrl = _settings.oauthUrl,
          oauthClientId = _settings.oauthClientId;

      return new OAuth2Client(oauthUrl, oauthClientId, window.fetch).userCredentials(user, pass).then(function (response) {
        _newArrowCheck(this, _this16);

        return response.ok ? response : Promise.reject(response);
      }.bind(this));
    };

    _createClass(Client, [{
      key: "ready",
      get: function get() {
        return this._serviceWorker && this._ready;
      }
    }, {
      key: "legacyMode",
      get: function get() {
        return this._legacyMode;
      },
      set: function set(sw) {
        throw Error("legacyMode is a read-only property");
      }
    }, {
      key: "serviceWorker",
      get: function get() {
        if (!this._serviceWorker) {
          throw Error("proauth.js: serviceWorker has been not registered yet.");
        }
        return this._serviceWorker;
      },
      set: function set(sw) {
        var _this17 = this;

        if (this._serviceWorker) {
          this._serviceWorker.removeEventListener("message", this._onMessage);
        }

        this._ready = false;
        this._serviceWorker = sw;
        this._legacyMode = sw !== navigator.serviceWorker;

        sendMessage(sw, {
          namespace: this.settings.namespace,
          command: "init",
          params: [this.settings, this.sessionContainer.content]
        }).then(function (data) {
          _newArrowCheck(this, _this17);

          this._serviceWorker.addEventListener("message", this._onMessage);
          this._ready = !!data;
          // (todo): dispatch global ready event
        }.bind(this));
      }
    }]);

    return Client;
  }();

  var boot = function () {
    _newArrowCheck(this, _this);

    var settings = {
      // Put defaults here
      swSrc: "/service-worker.js",
      swOptions: {},
      oauthUrl: "/oauth",
      oauthClientId: "proauth",
      sessionStorage: "localStorage",
      namespace: document.origin && document.origin !== "null" ? document.origin : "",
      managedUrls: ["/" // Manage the current url root by default
      ]
    };

    // Copy user settings
    Object.assign(settings, window.proauth || {});

    // Patch settings
    settings.oauthUrl = absolutePath(settings.oauthUrl);
    for (var k in settings.managedUrls) {
      settings.managedUrls[k] = absolutePath(settings.managedUrls[k]);
    }

    var client = new Client(settings);

    return client;
  }.bind(this);

  var proauthClient = {
    client: boot()
  };

  var client = proauthClient.client;

  // Init elements for legacy mode
  var serviceWorker = new ServiceWorker(); // Fake serviceWorker
  fetch$2.install(serviceWorker.self); // FetchAPI proxy

  xhr.install(); // XMLHttpRequest to FetchAPI proxy

  // Setup service environment
  var originalFetch = fetch$2.fetch;

  var effectiveFetch = originalFetch.polyfill ? function () {
    _newArrowCheck(this, _this);

    xhr.uninstall();
    var ret = originalFetch.apply(undefined, arguments);
    xhr.install();
    return ret;
  }.bind(this) : originalFetch;

  var controller = new Controller(serviceWorker.self, effectiveFetch);
  client.serviceWorker = serviceWorker;

  var legacy = { fetch: fetch$2, xhr: xhr, serviceWorker: serviceWorker };
  var service = { controller: controller };
  var legacy$1 = { legacy: legacy, service: service, client: client };

  return legacy$1;
}();
//# sourceMappingURL=legacy.es2015.js.map
